#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>

#define TAG 1

int main(int argc, char ** argv) {

//The only argument here is the range, R, of the random numbers.

	int my_rank, world_size;

        char message[256], name[80];
        MPI_Status status;

	int j, k;
	int R = atoi(argv[1]);

	int seed;
	double rand1 = 0.0;
	double temp = 0.0;
	seed = time(NULL);
	srand(seed);
	int randval;
	int newrandval;
	int msgcounter = 0;

	MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

        MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
        MPI_Comm_size(MPI_COMM_WORLD, &world_size);

	rand1 = rand();
	temp = rand1 / (double) RAND_MAX;
	randval = R*temp;
	printf("Node %d: My random number is %d \n", my_rank, randval);


	if (my_rank == 0)
	{
		while(msgcounter < world_size-1)
		{
			MPI_Recv(&newrandval, 1, MPI_INT, MPI_ANY_SOURCE, TAG, MPI_COMM_WORLD, &status);
			msgcounter++;
			printf("Node %d: Received from node %d the random number is %d \n", my_rank, status.MPI_SOURCE, newrandval);
		}
	}
	
	if (my_rank != 0)
	{
			MPI_Send(&randval, 1, MPI_INT, 0, TAG, MPI_COMM_WORLD);
	}

    MPI_Finalize();

}
